【Codeforces Round 374 (Div 2)D】【贪心】 Maxim and Array n个数做K次±X使得乘积尽可能小

D. Maxim and Array
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Recently Maxim has found an array of n integers, needed by no one. He immediately come up with idea of changing it: he invented positive integer x and decided to add or subtract it from arbitrary array elements. Formally, by applying single operation Maxim chooses integer i (1 ≤ i ≤ n) and replaces the i-th element of array ai either with ai + x or with ai - x. Please note that the operation may be applied more than once to the same position.

Maxim is a curious minimalis, thus he wants to know what is the minimum value that the product of all array elements (i.e. ) can reach, if Maxim would apply no more than k operations to it. Please help him in that.

Input

The first line of the input contains three integers n, k and x (1 ≤ n, k ≤ 200 000, 1 ≤ x ≤ 109) — the number of elements in the array, the maximum number of operations and the number invented by Maxim, respectively.

The second line contains n integers a1, a2, ..., an () — the elements of the array found by Maxim.

Output

Print n integers b1, b2, ..., bn in the only line — the array elements after applying no more than k operations to the array. In particular,  should stay true for every 1 ≤ i ≤ n, but the product of all array elements should be minimum possible.

If there are multiple answers, print any of them.

Examples
input
5 3 1
5 4 3 5 2
output
5 4 3 5 -1 
input
5 3 1
5 4 3 5 5
output
5 4 0 5 5 
input
5 3 1
5 4 4 5 5
output
5 1 4 5 5 
input
3 2 7
5 4 2
output
5 11 -5 

#include<stdio.h>
#include<iostream>
#include<string.h>
#include<string>
#include<ctype.h>
#include<math.h>
#include<set>
#include<map>
#include<vector>
#include<queue>
#include<bitset>
#include<algorithm>
#include<time.h>
using namespace std;
void fre() { freopen("c://test//input.in", "r", stdin); freopen("c://test//output.out", "w", stdout); }
#define MS(x,y) memset(x,y,sizeof(x))
#define ls o<<1
#define rs o<<1|1
typedef long long LL;
typedef unsigned long long UL;
typedef unsigned int UI;
template <class T1, class T2>inline void gmax(T1 &a, T2 b) { if (b>a)a = b; }
template <class T1, class T2>inline void gmin(T1 &a, T2 b) { if (b<a)a = b; }
const int N = 2e5 + 10, M = 0, Z = 1e9 + 7, inf = 0x3f3f3f3f;
template <class T1, class T2>inline void gadd(T1 &a, T2 b) { a = (a + b) % Z; }
int casenum, casei;
int n, K, X;
LL a[N];
struct node
{
	LL x;
	int sg;
	int p;
	bool operator < (const node &b)const
	{
		if (abs(x) != abs(b.x))return abs(x) < abs(b.x);//使得绝对值小的排在前面
		return p < b.p;
	}
};
set< node >sot;
int main()
{
	while(~scanf("%d%d%d",&n,&K,&X))
	{
		sot.clear();
		int neg = 0;
		for (int i = 1; i <= n; ++i)
		{
			int x; scanf("%d", &x);
			int sg = (x >= 0 ? 1 : -1);
			if (x < 0)++neg;
			sot.insert({ x, sg, i });
		}
		if (neg % 2 == 0)//负数个数为偶数,这种情况下,我们要变号
		{
			while (K)
			{
				--K;
				LL x = sot.begin()->x;
				int sg = sot.begin()->sg;
				int p = sot.begin()->p;
				sot.erase(sot.begin());
				if ((x - X * sg) * sg <= 0)
				{
					sot.insert({ x - X * sg, -sg, p });
					break;
				}
				else
				{
					sot.insert({ x - X * sg, sg, p });
				}
			}
		}
		while (K)
		{
			--K;
			LL x = sot.begin()->x;
			int sg = sot.begin()->sg;
			int p = sot.begin()->p;
			sot.erase(sot.begin());
			sot.insert({ x + X * sg, sg, p });
		}
		for (auto it : sot)a[it.p] = it.x;
		for (int i = 1; i <= n; ++i)printf("%lld ", a[i]);
		puts("");
	}
	return 0;
}
/*
【trick&&吐槽】
这题我mdzz了。
=w= 数组开小导致TLE

【题意】
n个数,我们可以做k次操作,每次选定一个数,+x或-x,在这种条件下,让你求出怎么操作,可以使得乘积最小

【类型】
贪心

【分析】
显然,如果负数个数为奇数,我们只需要使得所有数符号不变的条件下,绝对值尽可能大(从绝对值较小者开始递增)
如果负数个数为偶数,我们要先使得一个绝对值最小的数变号(非负->负 或 负->非负),然后再做上面的操作

【时间复杂度&&优化】
O(klogn)

*/


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值